import os
import math
import time
import random

import numpy as np
import cv2 as cv
import tensorboard
import tensorflow as tf
import keras

from tensorflow.keras.callbacks import TensorBoard
from image_process import ImageProcessor

workspace = "C:/Users/corin/Desktop/Storage/[Projects]/Python/Capstone"
models = "C:/Users/corin/Desktop/Storage/[Projects]/Python/Capstone/Models"
datafiles = "C:/Users/corin/Desktop/Storage/[Projects]/Python/Capstone/Images"

if not os.path.exists(models):
    os.makedirs(models, exist_ok=True)

pcolor_types = [
    # "0", #봄웜라이트
    # "1", #봄웜브라이트
    # "2", #여름쿨뮤트
    # "3", #여름쿨라이트
    # "4", #가을웜딥
    # "5", #가을웜뮤트
    # "6", #겨울쿨브라이트
    # "7"  #겨울쿨딥
    "spring",
    "summer",
    "fall",
    "winter"
]

data = []
result = []

ip = ImageProcessor()

# for index, pctype in enumerate(pcolor_types):
#     pctype_import = datafiles + "/" + pctype
#     pctype_export = datafiles + "/output/" + pctype
    
#     output = pctype_export + "/kmeans.npy"
    
#     print("open directory:", pctype_import)
    
#     if not os.path.exists(pctype_export):
#         os.makedirs(pctype_export, exist_ok=True)
#     else:
#         if os.path.exists(output):
#             # for i in np.load(output):
#             #     data.append(i)
#             #     result.append(index)
#             continue
    
#     for file in os.listdir(pctype_import):
#         name, ext = os.path.splitext(file)
        
#         if ext in [".jpg", ".jpeg", ".png"]:
#             print("open file:", file, end=" | ")
            
#             image_path = pctype_import + "/" + file
#             image = cv.imread(image_path)
            
#             for i, f in enumerate(ip.image_get_face(image)):
#                 try:
#                     #cv.imwrite(pctype_export + "/" + name + "(" + str(i) + ")" + ext, f)
                    
#                     s = ip.image_get_skin(f)
#                     cv.imwrite(pctype_export + "/" + name + "(" + str(i) + ")" + ext, s)
                    
#                     print(i, end=" ")
#                 except Exception as e:
#                     print(e)
#                 finally:
#                     pass
#             print()
#         else:
#             print("skip file:", file)

clusters = 6
size = 0
for index, pctype in enumerate(pcolor_types):
    add_data = []
    add_result = []
    
    pctype_import = datafiles + "/" + pctype
    pctype_export = datafiles + "/output/" + pctype
    
    output = pctype_export + "/kmeans-hsv.npy"
    
    print("open directory:", pctype_import)
    
    if not os.path.exists(pctype_export):
        os.makedirs(pctype_export, exist_ok=True)
    else:
        if os.path.exists(output):
            narray = np.load(output)
            print(len(narray))
            for i in range(size, len(narray)):
                data.append(narray[i])
                result.append(index)
            continue

    for file in os.listdir(pctype_export):
        name, ext = os.path.splitext(file)
        
        if ext in [".jpg", ".jpeg", ".png", ".JPG", ".JPEG", ".PNG"]:
            print("open file:", file)
            
            image_path = pctype_export + "/" + file
            image = cv.imread(image_path)
            
            types = "HSV"
            kmeans = ip.image_get_kmeans(image, clusters, types=types)
            if kmeans.shape[0] == clusters:
                kmeans = kmeans.tolist()
                
                black = False
                j = 0
                if(types=="RGB"):
                    for i in range(0, len(kmeans)):
                        l = kmeans[i - j]
                        if math.floor(l[0]) == 0 and math.floor(l[1]) == 0 and math.floor(l[2]) == 0:
                            black = True
                            kmeans.pop(i - j)
                            j += 1;
                            print("remove black")
                elif(types=="HSV"):
                    for i in range(0, len(kmeans)):
                        l = kmeans[i - j]
                        if math.floor(l[2]) == 0:
                            black = True
                            kmeans.pop(i - j)
                            j += 1;
                            print("remove black")
                else:
                    pass
                
                if black == False:
                    kmeans.pop()
                
                if len(kmeans) == clusters-1:
                    add_data.append(kmeans)
                    add_result.append(index)
                else:
                    print("remove data", len(kmeans), "/", clusters-1)
            else:
                print("data error:", kmeans.shape[0])
        else:
            print("skip file:", file)
    
    data += add_data
    result += add_result
    
    np.save(output, np.array(data))

#(4514, 9, 3)
shuffle = list(i for i in range(0, len(data)))
random.shuffle(shuffle)

shuffle_data = list()
shuffle_result = list()
for i in shuffle:
    shuffle_data.append(data[i])
    shuffle_result.append(int(result[i]))

test_percentage = 0.1
test_index = math.floor(len(data) * (1 - test_percentage))

trainX = np.array(shuffle_data[:test_index])/255
trainY = tf.one_hot(shuffle_result[:test_index], depth=4)

testX = np.array(shuffle_data[test_index:])/255
testY = tf.one_hot(shuffle_result[test_index:], depth=4)

print(trainX.shape)
print(trainY.shape)

model = tf.keras.Sequential([
    #tf.keras.layers.Conv1D(16, 3, input_shape=(clusters-1, 3), padding="same", activation="relu"),
    #tf.keras.layers.MaxPooling1D(4, 2),
    #tf.keras.layers.Conv1D(8, 3, padding="same", activation="relu"),
    #tf.keras.layers.Conv1D(4, 3, padding="same", activation="relu"),
    
    #tf.keras.layers.Dense(64, activation="relu"),
    tf.keras.layers.Dense(32, input_shape=(clusters-1, 3), activation="relu"),
    tf.keras.layers.Flatten(),
    tf.keras.layers.Dense(128, activation="relu"),
    #tf.keras.layers.Dropout(0.1),
    tf.keras.layers.Dense(64, activation="relu"),
    tf.keras.layers.Dense(32, activation="relu"),
    #tf.keras.layers.Dropout(0.1),
    tf.keras.layers.Dense(16, activation="relu"),
    tf.keras.layers.Dense(4, activation="softmax")
])
model.summary()

# tb = TensorBoard(log_dir='logs/{}'.format("Model-Alpha"+str(int(time.time()))))

# model = keras.models.load_model(r"C:\Users\corin\Desktop\Storage\[Projects]\Python\Capstone\Models\alpha\model2.h5")

model.compile(loss="categorical_crossentropy", optimizer="adam", metrics=["accuracy"])
model.fit(trainX, trainY, validation_data=(testX,  testY), epochs=30, batch_size=4)#, callbacks=[tb])

# model.save(models + "/alpha/model2.h5")

test_loss, test_acc = model.evaluate(testX,  testY)
print('Test accuracy:', test_acc)


image = cv.imread(r"C:\Users\corin\Desktop\4.jpg")
types = "HSV"

predicts = [];

for i in range(0, 10):
    print("Step:", i+1)
    result = [];
    kmeans = ip.image_get_kmeans(image, clusters, types=types)
    if kmeans.shape[0] == clusters:
        kmeans = kmeans.tolist()
        
        black = False
        j = 0
        if(types=="RGB"):
            for i in range(0, len(kmeans)):
                l = kmeans[i - j]
                if math.floor(l[0]) == 0 and math.floor(l[1]) == 0 and math.floor(l[2]) == 0:
                    black = True
                    kmeans.pop(i - j)
                    j += 1;
                    print("remove black")
        elif(types=="HSV"):
            for i in range(0, len(kmeans)):
                l = kmeans[i - j]
                if math.floor(l[2]) == 0:
                    black = True
                    kmeans.pop(i - j)
                    j += 1;
                    print("remove black")
        else:
            pass
        
        if black == False:
            kmeans.pop()
        
        if len(kmeans) == clusters-1:
            result.append(kmeans)
        else:
            print("remove data", len(kmeans), "/", clusters-1)
    else:
        print("data error:", kmeans.shape[0])
    
    predict = np.array(result)
    predicted = model.predict(predict)
    print(predicted)
    predicts.append(predicted.tolist()[0])

result = np.array([0, 0, 0, 0]);
for i in predicts:
    result = np.add(result, i)

result = result/10

print(result)
print(np.argmax(result) + 1, end=" : ")
print(np.max(result))